
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.io.*;
import java.util.*;
import java.awt.event.*;


class Frame1 extends JFrame {
    JPanel contentPane;
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    JLabel jLabel1 = new JLabel();
    JTextField jTextField1 = new JTextField();
    JButton jButton1 = new JButton();

    BorderLayout borderLayout2 = new BorderLayout();
    FlowLayout flowLayout1 = new FlowLayout();
    BorderLayout borderLayout1 = new BorderLayout();

    JScrollPane jScrollPane1 = new JScrollPane();
    JScrollPane jScrollPane2 = new JScrollPane();
    JComboBox jComboBox1 = new JComboBox();
    GridLayout gridLayout1 = new GridLayout();
    JTextPane jTextPane1 = new JTextPane();
    JTextPane jTextPane2 = new JTextPane();
    TitledBorder titledBorder1 = new TitledBorder("");
    public Frame1() {
        try {
            setDefaultCloseOperation(EXIT_ON_CLOSE);
            jbInit();
            cbInit();

        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void cbInit() throws Exception {
        File pathName = new File("data");
        if (!pathName.exists() || pathName.isDirectory()) {
            pathName.mkdir();
        }
        if (pathName.exists() && pathName.isDirectory()) {
            String[] fN = pathName.list();
            if (fN.length == 0) {
                jComboBox1.addItem("0 available");
                String warn =
                        " No dictionaries found!\n Copy dictionaries into \"data\" directory.\n";
                warn += " For example copy english-french.txt file\n into \"data\" directory \n and restart this application.\n";
                warn +=
                        " You can download many free dictionaries at:\n http://www.dicts.info/uddl.php";
                jTextPane1.setText(warn);
            } else {
                int cnt = 0;
                for (int i = 0; i < fN.length; i++) {
                    if (fN[i].indexOf(".txt") >= 0) {
                        cnt++;
                    }
                }
                jComboBox1.addItem(cnt + " available");
                for (int i = 0; i < fN.length; i++) {
                    if (fN[i].indexOf(".txt") >= 0) {
                        jComboBox1.addItem(fN[i]);
                    }
                }
            }
            jTextField1.requestFocus();
        } else {
            jComboBox1.addItem("0 available");
            jTextPane1.setText("Data directory could not be created!");
        }
    }


    void jButton1_actionPerformed(ActionEvent e) {
        params();
    }

    void jTextField1_actionPerformed(ActionEvent e) {
        params();
    }

// Method reads parameters from UI searches in the file and prints results.
    public void params() {
        String word = (String) jComboBox1.getSelectedItem();
        if (word != null && word.indexOf(".txt") >= 0) {
            String[] arr = searchfile("data/" + word, jTextField1.getText());
            jTextPane1.setText(arr[0]);
            jTextPane2.setText(arr[1]);
            //System.out.println(jScrollPane1.getX());
            jTextField1.requestFocus();
            jTextField1.selectAll();
            jScrollPane1.getVerticalScrollBar().setValue(0);
            jScrollPane2.getVerticalScrollBar().setValue(0);
        }
    }

// This method searches word in the selected dictionary.
// This is a brute force method which reads whole file each search.
// Method is fast enough even for big dictionaries on fast computers.
public String[] searchfile(String input, String wo) {
String[] arb = new String[2];
try {
  BufferedReader in1 = new BufferedReader(new InputStreamReader(new FileInputStream(input), "UTF-8"));
  StringBuffer res1 = new StringBuffer();
  StringBuffer res2 = new StringBuffer();
  StringBuffer tem1 = new StringBuffer();
  StringBuffer tem2 = new StringBuffer();
  StringBuffer temb1 = new StringBuffer();
  StringBuffer temb2 = new StringBuffer();
  String[] arr = new String[2];
  String str;
  int cn1 = 0;
  int cn2 = 0;

while ((str = in1.readLine()) != null) { //*******************
 arr = cols(str + "\t");
 if (arr[0].indexOf(wo) >= 0 && cn1 < 150) {
  if (arr[0].equals(wo))res1.append(" " + (arr[0] + " = "+ arr[1]+" "+arr[2] + " " + arr[3]).trim()+ "\n");
   else {
	if (arr[0].indexOf(wo) == 0) {
		tem1.append(" " + (arr[0] + " = " + arr[1] +" " + arr[2] + " " + arr[3]).trim() +"\n");
		cn1++;
  	  }
	}
  }
if (arr[1].indexOf(wo) >= 0 && cn2 < 150) {
  if (arr[1].equals(wo))res2.append(" " + (arr[1] + " = " + arr[0] + " "+ arr[2] + " " + arr[3]).trim() + "\n");
  else {
    if (arr[1].indexOf(wo) == 0) {
    temb1.append(" " +(arr[1] + " = " + arr[0] + " " + arr[2] +" " + arr[3]).trim() + "\n");
    cn2++;
	}
  }
 }
} //************************

	res1.append(tem1.toString() + "" + tem2.toString());
	res2.append(temb1.toString() + "" + temb2.toString());
	arb[0] = res1.toString();
	arb[1] = res2.toString();
	in1.close();
	} catch (IOException e) {
		System.out.println("Error: " + e);
	}
	return arb;
}



// This method splits the line into array of strings - it is about 10x faster than normal split()
    public static String[] cols(String word) {
        String[] arr = new String[4];
        arr[0] = "";
        arr[1] = "";
        int pos1 = 0;
        int pos2 = 0;
        int len = word.length();

        pos1 = word.indexOf("	");
        if (pos1 > 0) {
            arr[0] = word.substring(0, pos1);
        }

        pos2 = word.indexOf("	", pos1 + 1);
        if (pos1 > 0 && pos2 > 0) {
            arr[1] = word.substring(pos1 + 1, pos2);
            pos1 = pos2;
        }

        pos2 = word.indexOf("	", pos1 + 1);
        if (pos1 > 0 && pos2 > 0) {
            arr[2] = word.substring(pos1 + 1, pos2);
            pos1 = pos2;
        } else {
            arr[2] = "";
        }

        pos2 = word.indexOf("	", pos1 + 1);
        if (pos1 > 0 && pos2 > 0) {
            arr[3] = word.substring(pos1 + 1, pos2);
        } else {
            arr[3] = "";
        }

        return arr;
    }


//***************************************************************************************
//Only automatically generated code is below

     private void jbInit() throws Exception {
         contentPane = (JPanel) getContentPane();
         contentPane.setLayout(borderLayout1);
         setSize(new Dimension(600, 420));
         setTitle("Simple Dictionary Application 1.02");
         jPanel1.setLayout(borderLayout2);
         jPanel2.setBackground(Color.lightGray);
         jPanel2.setBorder(null);
         jPanel2.setLayout(flowLayout1);
         jPanel3.setBorder(null);
         jPanel3.setLayout(gridLayout1);
         jButton1.setText("Search");
         jButton1.addActionListener(new Frame1_jButton1_actionAdapter(this));
         jLabel1.setText("Dictionary");
         jTextField1.setPreferredSize(new Dimension(100, 25));
         jTextField1.addActionListener(new Frame1_jTextField1_actionAdapter(this));
         jButton1.setPreferredSize(new Dimension(80, 25));
         jComboBox1.setPreferredSize(new Dimension(190, 25));
         jTextPane1.setBorder(null);
         jTextPane1.setEditable(false);
         jTextPane1.setFont(new java.awt.Font("Default", Font.PLAIN, 12));
         jTextPane2.setFont(new java.awt.Font("Default", Font.PLAIN, 12));
         jTextPane2.setBorder(null);
         jTextPane2.setEditable(false);
         jScrollPane1.setBorder(null);
         jScrollPane1.setDoubleBuffered(true);
         jScrollPane2.setAutoscrolls(true);
         jScrollPane2.setBorder(null);
         jScrollPane2.setDoubleBuffered(true);
         contentPane.add(jPanel1, java.awt.BorderLayout.CENTER);
         jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);
         jPanel1.add(jPanel2, java.awt.BorderLayout.NORTH);
         jPanel2.add(jLabel1);
         jPanel2.add(jComboBox1);
         jPanel2.add(jTextField1);
         jPanel2.add(jButton1);
         jPanel3.add(jScrollPane1, null);
         jScrollPane1.getViewport().add(jTextPane1);
         jPanel3.add(jScrollPane2, null);
         jScrollPane2.getViewport().add(jTextPane2);
         // jScrollPane2.add(jTextArea2);

     }

}


class Frame1_jTextField1_actionAdapter implements ActionListener {
    private Frame1 adaptee;
    Frame1_jTextField1_actionAdapter(Frame1 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {

        adaptee.jTextField1_actionPerformed(e);
    }
}


class Frame1_jButton1_actionAdapter implements ActionListener {
    private Frame1 adaptee;
    Frame1_jButton1_actionAdapter(Frame1 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}



/**
 * <p>Title: Simple dictionary application</p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: All free dictionaries project http://www.Dicts.info</p>
 *
 */
public class SDA {
    boolean packFrame = false;

    /**
     * Construct and show the application.
     */
 SDA() {
        Frame1 frame = new Frame1();
        // Validate frames that have preset sizes
        // Pack frames that have useful preferred size info, e.g. from their layout
        if (packFrame) {
            frame.pack();
        } else {
            frame.validate();
        }

        // Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2,
                          (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * Application entry point.
     *
     * @param args String[]
     */
    public static void main(String[] args) {
/*
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
*/
Thread th=new th();

new th().start();
th.setPriority(1);
/*

                try {
                    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                    //UIManager.getSystemLookAndFeelClassName()
                } catch (Exception exception) {
                    exception.printStackTrace();
                }

                new app();
*/
   /*    }
        });*/
    }

static class th extends Thread {
   public th() {
        }
   public void run() {
    try {
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
   } catch (Exception exception) {
    exception.printStackTrace();
     }
  new SDA();
  }
 }



    private void jbInit() throws Exception {
    }
}
